Index: pjproject/trunk/pjmedia/docs/doxygen.cfg
===================================================================
--- pjproject/trunk/pjmedia/docs/doxygen.cfg	(revision 188)
+++ pjproject/trunk/pjmedia/docs/doxygen.cfg	(revision 189)
@@ -501,5 +501,5 @@
 # standard header.
 
-HTML_HEADER            = ../pjlib/docs/header.html
+HTML_HEADER            = docs/header.html
 
 # The HTML_FOOTER tag can be used to specify a personal HTML footer for 
@@ -507,5 +507,5 @@
 # standard footer.
 
-HTML_FOOTER            = ../pjlib/docs/footer.html
+HTML_FOOTER            = docs/footer.html
 
 # The HTML_STYLESHEET tag can be used to specify a user defined cascading 
Index: pjproject/trunk/pjmedia/include/pjmedia/codec.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 188)
+++ pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 189)
@@ -36,4 +36,12 @@
  * @ingroup PJMEDIA
  * @{
+ *
+ * The codec manager is used to manage all codec capabilities in the endpoint.
+ * Library implementors can extend PJMEDIA codec capabilities by creating 
+ * a codec factory for a new codec, and register the codec factory to
+ * codec manager so that the codec can be used by the rest of application.
+ *
+ * When used with media endpoint (pjmedia_endpt), application can retrieve
+ * the codec manager instance by calling #pjmedia_endpt_get_codec_mgr().
  */
 
Index: pjproject/trunk/pjmedia/include/pjmedia/endpoint.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/endpoint.h	(revision 188)
+++ pjproject/trunk/pjmedia/include/pjmedia/endpoint.h	(revision 189)
@@ -35,6 +35,5 @@
  *
  * A reference to media endpoint instance is required when application wants
- * to create a media session (#pj_media_session_create or 
- * #pj_media_session_create_from_sdp).
+ * to create a media session (#pjmedia_session_create()).
  */
 
Index: pjproject/trunk/pjmedia/include/pjmedia/sdp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/sdp.h	(revision 188)
+++ pjproject/trunk/pjmedia/include/pjmedia/sdp.h	(revision 189)
@@ -33,5 +33,5 @@
  *
  * The basic SDP session descriptor and elements are described in header
- * file <pre><pjmedia/sdp.h></pre>. This file contains declaration for
+ * file <b><pjmedia/sdp.h></b>. This file contains declaration for
  * SDP session descriptor and SDP media descriptor, along with their
  * attributes. This file also declares functions to parse SDP message.
Index: pjproject/trunk/pjmedia/include/pjmedia/session.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/session.h	(revision 188)
+++ pjproject/trunk/pjmedia/include/pjmedia/session.h	(revision 189)
@@ -45,4 +45,9 @@
  * This module provides functions to create and manage multimedia
  * sessions.
+ *
+ * Application creates the media session by calling #pjmedia_session_create(),
+ * normally after it has completed negotiating both SDP offer and answer.
+ * The session creation function creates the media session (including
+ * media streams) based on the content of local and remote SDP.
  */
 
@@ -63,5 +68,5 @@
 
 /**
- * Create new session offering based on the local and remote SDP.
+ * Create media session based on the local and remote SDP.
  * The session will start immediately.
  *
Index: pjproject/trunk/pjmedia/include/pjmedia/stream.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/stream.h	(revision 188)
+++ pjproject/trunk/pjmedia/include/pjmedia/stream.h	(revision 189)
@@ -45,4 +45,9 @@
  *  - encoding channel, which transmits unidirectional media to remote, and
  *  - decoding channel, which receives unidirectional media from remote.
+ *
+ * Application normally does not need to create the stream directly; it 
+ * creates media session instead. The media session will create the media
+ * streams as necessary, according to the media descriptors that present
+ * in local and remote SDP.
  */
 