Index: pjproject/trunk/pjsip/build/pjsip.dsw
===================================================================
--- pjproject/trunk/pjsip/build/pjsip.dsw	(revision 186)
+++ pjproject/trunk/pjsip/build/pjsip.dsw	(revision 197)
@@ -94,4 +94,16 @@
 ###############################################################################
 
+Project: "pjsip_simple"=.\pjsip_simple.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
 Project: "pjsip_ua"=.\pjsip_ua.dsp - Package Owner=<4>
 
@@ -135,4 +147,7 @@
     Project_Dep_Name pjlib_util
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjsip_simple
+    End Project Dependency
 }}}
 
Index: pjproject/trunk/pjsip/build/pjsip_simple.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_simple.dsp	(revision 186)
+++ pjproject/trunk/pjsip/build/pjsip_simple.dsp	(revision 197)
@@ -33,14 +33,14 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 0
-# PROP BASE Output_Dir "./output/pjsip_simple_Win32_Release"
-# PROP BASE Intermediate_Dir "./output/pjsip_simple_Win32_Release"
+# PROP BASE Output_Dir "./output/pjsip-simple-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir "./output/pjsip-simple-i386-win32-vc6-release"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 0
-# PROP Output_Dir "./output/pjsip_simple_Win32_Release"
-# PROP Intermediate_Dir "./output/pjsip_simple_Win32_Release"
+# PROP Output_Dir "./output/pjsip-simple-i386-win32-vc6-release"
+# PROP Intermediate_Dir "./output/pjsip-simple-i386-win32-vc6-release"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "../src" /I "../../pjlib/src" /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "../include" /I "../../pjlib-util/include" /I "../../pjlib/include" /D "NDEBUG" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "WIN32" /D "_MBCS" /D "_LIB" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
@@ -50,5 +50,5 @@
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 /nologo /out:"../lib/pjsip_simple_vc6.lib"
+# ADD LIB32 /nologo /out:"../lib/pjsip-simple-i386-win32-vc6-release.lib"
 
 !ELSEIF  "$(CFG)" == "pjsip_simple - Win32 Debug"
@@ -56,14 +56,14 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 1
-# PROP BASE Output_Dir "./output/pjsip_simple_Win32_Debug"
-# PROP BASE Intermediate_Dir "./output/pjsip_simple_Win32_Debug"
+# PROP BASE Output_Dir "./output/pjsip-simple-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir "./output/pjsip-simple-i386-win32-vc6-debug"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 1
-# PROP Output_Dir "./output/pjsip_simple_Win32_Debug"
-# PROP Intermediate_Dir "./output/pjsip_simple_Win32_Debug"
+# PROP Output_Dir "./output/pjsip-simple-i386-win32-vc6-debug"
+# PROP Intermediate_Dir "./output/pjsip-simple-i386-win32-vc6-debug"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "../src" /I "../../pjlib/src" /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /FR /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib-util/include" /I "../../pjlib/include" /D "_DEBUG" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "WIN32" /D "_MBCS" /D "_LIB" /FR /YX /FD /GZ /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
@@ -73,5 +73,5 @@
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 /nologo /out:"../lib/pjsip_simple_vc6d.lib"
+# ADD LIB32 /nologo /out:"../lib/pjsip-simple-i386-win32-vc6-debug.lib"
 
 !ENDIF 
@@ -86,25 +86,21 @@
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\event_notify.c
+SOURCE="..\src\pjsip-simple\evsub.c"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\event_notify_msg.c
+SOURCE="..\src\pjsip-simple\evsub_msg.c"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\messaging.c
+SOURCE="..\src\pjsip-simple\pidf.c"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\pidf.c
+SOURCE="..\src\pjsip-simple\presence.c"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\presence.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip_simple\xpidf.c
+SOURCE="..\src\pjsip-simple\xpidf.c"
 # End Source File
 # End Group
@@ -114,29 +110,33 @@
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\event_notify.h
+SOURCE="..\include\pjsip-simple\errno.h"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\event_notify_msg.h
+SOURCE="..\include\pjsip-simple\evsub.h"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\messaging.h
+SOURCE="..\include\pjsip-simple\evsub_msg.h"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\pidf.h
+SOURCE="..\include\pjsip-simple\pidf.h"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple.h
+SOURCE=..\include\pjsip_simple.h
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\presence.h
+SOURCE="..\include\pjsip-simple\presence.h"
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\pjsip_simple\xpidf.h
+SOURCE="..\include\pjsip-simple\types.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjsip-simple\xpidf.h"
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/build/pjsip_ua.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_ua.dsp	(revision 186)
+++ pjproject/trunk/pjsip/build/pjsip_ua.dsp	(revision 197)
@@ -33,11 +33,11 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 0
-# PROP BASE Output_Dir ".\output\pjsip_ua_vc6_Release"
-# PROP BASE Intermediate_Dir ".\output\pjsip_ua_vc6_Release"
+# PROP BASE Output_Dir ".\output\pjsip-ua-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir ".\output\pjsip-ua-i386-win32-vc6-release"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 0
-# PROP Output_Dir ".\output\pjsip_ua_vc6_Release"
-# PROP Intermediate_Dir ".\output\pjsip_ua_vc6_Release"
+# PROP Output_Dir ".\output\pjsip-ua-i386-win32-vc6-release"
+# PROP Intermediate_Dir ".\output\pjsip-ua-i386-win32-vc6-release"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
@@ -51,5 +51,5 @@
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 /nologo /out:"../lib/pjsip_ua_vc6s.lib"
+# ADD LIB32 /nologo /out:"../lib/pjsip-ua-i386-win32-vc6-release.lib"
 
 !ELSEIF  "$(CFG)" == "pjsip_ua - Win32 Debug"
@@ -57,11 +57,11 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 1
-# PROP BASE Output_Dir ".\output\pjsip_ua_vc6_Debug"
-# PROP BASE Intermediate_Dir ".\output\pjsip_ua_vc6_Debug"
+# PROP BASE Output_Dir ".\output\pjsip-ua-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir ".\output\pjsip-ua-i386-win32-vc6-debug"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 1
-# PROP Output_Dir ".\output\pjsip_ua_vc6_Debug"
-# PROP Intermediate_Dir ".\output\pjsip_ua_vc6_Debug"
+# PROP Output_Dir ".\output\pjsip-ua-i386-win32-vc6-debug"
+# PROP Intermediate_Dir ".\output\pjsip-ua-i386-win32-vc6-debug"
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
@@ -75,5 +75,5 @@
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 /nologo /out:"../lib/pjsip_ua_vc6sd.lib"
+# ADD LIB32 /nologo /out:"../lib/pjsip-ua-i386-win32-vc6-debug.lib"
 
 !ENDIF 
@@ -93,11 +93,4 @@
 
 SOURCE="..\src\pjsip-ua\sip_reg.c"
-
-!IF  "$(CFG)" == "pjsip_ua - Win32 Release"
-
-!ELSEIF  "$(CFG)" == "pjsip_ua - Win32 Debug"
-
-!ENDIF 
-
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/build/pjsua.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsua.dsp	(revision 186)
+++ pjproject/trunk/pjsip/build/pjsua.dsp	(revision 197)
@@ -33,11 +33,11 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 0
-# PROP BASE Output_Dir ".\output\pjsua_vc6_Release"
-# PROP BASE Intermediate_Dir ".\output\pjsua_vc6_Release"
+# PROP BASE Output_Dir ".\output\pjsua-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir ".\output\pjsua-i386-win32-vc6-release"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 0
-# PROP Output_Dir ".\output\pjsua_vc6_Release"
-# PROP Intermediate_Dir ".\output\pjsua_vc6_Release"
+# PROP Output_Dir ".\output\pjsua-i386-win32-vc6-release"
+# PROP Intermediate_Dir ".\output\pjsua-i386-win32-vc6-release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
@@ -59,11 +59,11 @@
 # PROP BASE Use_MFC 0
 # PROP BASE Use_Debug_Libraries 1
-# PROP BASE Output_Dir ".\output\pjsua_vc6_Debug"
-# PROP BASE Intermediate_Dir ".\output\pjsua_vc6_Debug"
+# PROP BASE Output_Dir ".\output\pjsua-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir ".\output\pjsua-i386-win32-vc6-debug"
 # PROP BASE Target_Dir ""
 # PROP Use_MFC 0
 # PROP Use_Debug_Libraries 1
-# PROP Output_Dir ".\output\pjsua_vc6_Debug"
-# PROP Intermediate_Dir ".\output\pjsua_vc6_Debug"
+# PROP Output_Dir ".\output\pjsua-i386-win32-vc6-debug"
+# PROP Intermediate_Dir ".\output\pjsua-i386-win32-vc6-debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
@@ -111,4 +111,8 @@
 # Begin Source File
 
+SOURCE=..\src\pjsua\pjsua_pres.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\pjsua\pjsua_reg.c
 # End Source File